echo off
cls
@cd/d "%~dp0"
rem   Microsoft.NET
if not exist %SystemRoot%\Microsoft.NET\Framework\v2.0.50727\ (
	color 0C
	@echo ERROR: Microsoft.NET is not installed
	goto end
	)

if not exist %SystemRoot%\Microsoft.NET\Framework64\v2.0.50727\ (
			color 0E
			@echo Microsoft.NET x64 is not supported on Windows x32
			goto win32
			)

@echo -----------------------------------------------
@echo                FRAMEWORK 64
@echo -----------------------------------------------
rem  XMLGOSTSigner.dll  Framework 64
if not exist %SystemRoot%\Microsoft.NET\Framework64\v2.0.50727\XMLGOSTSigner.dll (
	copy XMLGOSTSigner.dll %SystemRoot%\Microsoft.NET\Framework64\v2.0.50727\
	)

rem   XMLGOSTSigner.dll  Framework 64
if exist %SystemRoot%\Microsoft.NET\Framework64\v2.0.50727\XMLGOSTSigner.dll (
		color 0E
		@echo XMLGOSTSigner.dll copied to Framework 64
		) else (
			color 0C
			@echo ERROR: Installation in Framework 64 is not complete
			)

rem  XMLGOSTSigner.dll  Framework 64
if not exist %SystemRoot%\Microsoft.NET\Framework64\v2.0.50727\XMLGOSTSigner.tlb (
	@echo off
	%SystemRoot%\Microsoft.NET\Framework64\v2.0.50727\regasm.exe %SystemRoot%\Microsoft.NET\Framework64\v2.0.50727\XMLGOSTSigner.dll /tlb /codebase
	)

rem   XMLGOSTSigner.dll  Framework
if exist %SystemRoot%\Microsoft.NET\Framework64\v2.0.50727\XMLGOSTSigner.tlb (
	color 0A
	@echo XMLGOSTSigner.dll registered in Framework 64
	) else (
			color 0C
			@echo ERROR: Registration in Framework 64 is not complete
			)

:win32
@echo -----------------------------------------------
@echo                FRAMEWORK 32
@echo -----------------------------------------------
rem  XMLGOSTSigner.dll  Framework
if not exist %SystemRoot%\Microsoft.NET\Framework\v2.0.50727\XMLGOSTSigner.dll (
	copy XMLGOSTSigner.dll %SystemRoot%\Microsoft.NET\Framework\v2.0.50727\
	)

rem   XMLGOSTSigner.dll  Framework
if exist %SystemRoot%\Microsoft.NET\Framework\v2.0.50727\XMLGOSTSigner.dll (
		color 0E
		@echo XMLGOSTSigner.dll copied to Framework
		) else (
			color 0C
			@echo ERROR: Installation in Framework 32 is not complete
			)

rem  XMLGOSTSigner.dll  Framework
if not exist %SystemRoot%\Microsoft.NET\Framework\v2.0.50727\XMLGOSTSigner.tlb (
	@echo off
	%SystemRoot%\Microsoft.NET\Framework\v2.0.50727\regasm.exe %SystemRoot%\Microsoft.NET\Framework\v2.0.50727\XMLGOSTSigner.dll /tlb /codebase
	)

rem   XMLGOSTSigner.dll  Framework
if exist %SystemRoot%\Microsoft.NET\Framework\v2.0.50727\XMLGOSTSigner.tlb (
	color 0A
	@echo XMLGOSTSigner.dll registered in Framework
	) else (
			color 0C
			@echo ERROR: Registration in Framework 32 is not complete
			)

:end
@echo -----------------------------------------------
pause